import { handles } from '@graphpolaris/querybuilder/usecases';
import { useTheme } from '@mui/material';
import { Handle, Position } from 'react-flow-renderer';
import cn from 'classnames';

import styles from './relationpill.module.scss';

/**
 * Component to render a relation flow element
 * @param { FlowElement<RelationData>} param0 The data of a relation flow element.
 */
export default function RelationRFPill({ data }: { data: any }) {
  const theme = useTheme();

  // const minRef = useRef<HTMLInputElement>(null);
  // const maxRef = useRef<HTMLInputElement>(null);

  // const [readOnlyMin, setReadOnlyMin] = useState(true);
  // const [readOnlyMax, setReadOnlyMax] = useState(true);

  // const onDepthChanged = (depth: string) => {
  //   // Don't allow depth above 99
  //   const limit = 99;
  //   if (data != undefined) {
  //     data.depth.min = data.depth.min >= limit ? limit : data.depth.min;
  //     data.depth.max = data.depth.max >= limit ? limit : data.depth.max;

  //     // Check for for valid depth: min <= max
  //     if (depth == 'min') {
  //       if (data.depth.min > data.depth.max) data.depth.max = data.depth.min;
  //       setReadOnlyMin(true);
  //     } else if (depth == 'max') {
  //       if (data.depth.max < data.depth.min) data.depth.min = data.depth.max;
  //       setReadOnlyMax(true);
  //     }

  //     // Set to the correct width
  //     if (maxRef.current)
  //       maxRef.current.style.maxWidth = calcWidth(data.depth.max);
  //     if (minRef.current)
  //       minRef.current.style.maxWidth = calcWidth(data.depth.min);
  //   }
  // };

  // const calcWidth = (data: number) => {
  //   return data.toString().length + 0.5 + 'ch';
  // };

  return (
    <div className={styles.relation}>
      <div
        className={styles.arrowLeft}
        style={{
          borderRightColor: theme.palette.queryBuilder.relation.background,
        }}
      />
      <div
        className={cn(styles.contentWrapper, {
          [styles.highlighted]: data.suggestedForConnection,
        })}
        style={{
          color: theme.palette.queryBuilder.text,
          background: theme.palette.queryBuilder.relation.background,
        }}
      >
        <Handle
          id={handles.relation.fromEntity}
          type="target"
          position={Position.Left}
          className={styles.handleLeft}
          style={
            data?.isFromEntityConnected ? { borderRightColor: '#2e2e2e' } : {} // TODO: this should be color from theme
          }
        />
        <span className={styles.content} title={data.name}>
          {data.name}
        </span>
        <Handle
          id={handles.relation.toEntity}
          type="source"
          position={Position.Right}
          className={styles.handleRight}
          style={
            data?.isToEntityConnected ? { borderLeftColor: '#2e2e2e' } : {}
          }
        />
      </div>
      <div
        className={styles.arrowRight}
        style={{
          borderLeftColor: theme.palette.queryBuilder.relation.background,
        }}
      />
    </div>
  );
}
